summaryrefslogtreecommitdiff
path: root/tests/tail-2/F-vs-rename.sh
diff options
context:
space:
mode:
authorStephane Chazelas <stephane.chazelas@gmail.com>2015-02-03 21:22:06 +0000
committerPádraig Brady <P@draigBrady.com>2015-03-31 11:55:32 +0100
commitd313a0b24234d3366ec263111469f219f5b4634f (patch)
tree60f0b5c02f43a38060ee21933c06aae4d2361d74 /tests/tail-2/F-vs-rename.sh
parent52209ee547476aba6827848705cfa15484df78bd (diff)
downloadcoreutils-d313a0b24234d3366ec263111469f219f5b4634f.tar.xz
tail: fix -f to follow changes after a rename
* src/tail.c (tail_forever_inotify): Only monitor write()s and truncate()s to files in --follow=descriptor mode, thus avoiding the bug where we removed the watch on renamed files. Also adjust the inotify event processing code that is now significant only in --follow=name mode. * tests/tail-2/F-vs-rename.sh: Improve this existing test by running in both polling and inotify modes. * tests/tail-2/f-vs-rename.sh: A new test based on the existing one. * tests/local.mk: Reference the new test. * NEWS: Mention the bug. Fixes http://bugs.gnu.org/19760
Diffstat (limited to 'tests/tail-2/F-vs-rename.sh')
-rwxr-xr-xtests/tail-2/F-vs-rename.sh94
1 files changed, 48 insertions, 46 deletions
diff --git a/tests/tail-2/F-vs-rename.sh b/tests/tail-2/F-vs-rename.sh
index cb6a3ed8b..f95b71a6f 100755
--- a/tests/tail-2/F-vs-rename.sh
+++ b/tests/tail-2/F-vs-rename.sh
@@ -1,7 +1,7 @@
#!/bin/sh
-# demonstrate that tail -F works when renaming the tailed files
-# Before coreutils-8.3, tail -F a b would stop tracking additions to b
-# after "mv a b".
+# Demonstrate that tail -F works when renaming the tailed files.
+# Between coreutils 7.5 and 8.2 inclusive, 'tail -F a b' would
+# stop tracking additions to b after 'mv a b'.
# Copyright (C) 2009-2015 Free Software Foundation, Inc.
@@ -21,55 +21,57 @@
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ tail
-touch a b || framework_failure_
-
-debug='---disable-inotify'
-debug=
-tail $debug -F -s.1 a b > out 2>&1 & pid=$!
-
check_tail_output()
{
local delay="$1"
- grep "$tail_re" out > /dev/null ||
+ grep "$tail_re" out ||
{ sleep $delay; return 1; }
}
-# Wait up to 12.7s for tail to start
-echo x > a
-tail_re='^x$' retry_delay_ check_tail_output .1 7 || fail=1
-
-mv a b || fail=1
-
-# Wait 12.7s for this diagnostic:
-# tail: 'a' has become inaccessible: No such file or directory
-tail_re='inaccessible' retry_delay_ check_tail_output .1 7 || fail=1
-
-echo x > a
-# Wait up to 12.7s for this to appear in the output:
-# "tail: '...' has appeared; following end of new file"
-tail_re='has appeared' retry_delay_ check_tail_output .1 7 ||
- { echo "$0: a: unexpected delay?"; cat out; fail=1; }
-
-echo y >> b
-# Wait up to 12.7s for "y" to appear in the output:
-tail_f_vs_rename_2() {
- local delay="$1"
- tr '\n' @ < out | grep '@@==> b <==@y@$' > /dev/null ||
- { sleep $delay; return 1; }
-}
-retry_delay_ tail_f_vs_rename_2 .1 7 ||
- { echo "$0: b: unexpected delay?"; cat out; fail=1; }
-
-echo z >> a
-# Wait up to 12.7s for "z" to appear in the output:
-tail_f_vs_rename_3() {
- local delay="$1"
- tr '\n' @ < out | grep '@@==> a <==@z@$' > /dev/null ||
- { sleep $delay; return 1; }
-}
-retry_delay_ tail_f_vs_rename_3 .1 7 ||
- { echo "$0: a: unexpected delay?"; cat out; fail=1; }
+touch a b || framework_failure_
-kill -HUP $pid
+for mode in '' '---disable-inotify'; do
+ tail $mode -F -s.1 a b > out 2>&1 & pid=$!
+
+ # Wait up to 12.7s for tail to start.
+ echo x > a
+ tail_re='^x$' retry_delay_ check_tail_output .1 7 || fail=1
+
+ mv a b || fail=1
+
+ # Wait 12.7s for this diagnostic:
+ # tail: 'a' has become inaccessible: No such file or directory
+ tail_re='inaccessible' retry_delay_ check_tail_output .1 7 || fail=1
+
+ echo x > a
+ # Wait up to 12.7s for this to appear in the output:
+ # "tail: '...' has appeared; following end of new file"
+ tail_re='has appeared' retry_delay_ check_tail_output .1 7 ||
+ { echo "$0: a: unexpected delay?"; cat out; fail=1; }
+
+ echo y >> b
+ # Wait up to 12.7s for "y" to appear in the output:
+ tail_f_vs_rename_2() {
+ local delay="$1"
+ tr '\n' @ < out | grep '@@==> b <==@y@$' > /dev/null ||
+ { sleep $delay; return 1; }
+ }
+ retry_delay_ tail_f_vs_rename_2 .1 7 ||
+ { echo "$0: b: unexpected delay?"; cat out; fail=1; }
+
+ echo z >> a
+ # Wait up to 12.7s for "z" to appear in the output:
+ tail_f_vs_rename_3() {
+ local delay="$1"
+ tr '\n' @ < out | grep '@@==> a <==@z@$' > /dev/null ||
+ { sleep $delay; return 1; }
+ }
+ retry_delay_ tail_f_vs_rename_3 .1 7 ||
+ { echo "$0: a: unexpected delay?"; cat out; fail=1; }
+
+ kill $pid
+
+ wait $pid
+done
Exit $fail